part of mahg_essential_package;

abstract class MahgStatefulWidget<C extends MahgController>
    extends StatefulWidget {
  final C? controller;
  const MahgStatefulWidget(this.controller, {super.key});
}

abstract class MahgState<T extends MahgStatefulWidget, C extends MahgController>
    extends State<T> with LifecycleAware, LifecycleMixin {
  late C controller;

  C createController();

  @override
  void onLifecycleEvent(LifecycleEvent event) {
    if (event == LifecycleEvent.active) controller.state = this;
  }

  @override
  initState() {
    controller = createController();
    controller.init(this.widget);
    controller.initLate(this.widget).then((value) => controller.setState());
    super.initState();
  }

  @override
  dispose() {
    controller.dispose();
    super.dispose();
  }
}
